// MyRtfDlg.h : header file
//
// MyRtf -- word processor
// Author -- Frunza Adriana
// Created -- 19.09.2001
// Modified -- 
// 1. a) function added on 20 september 2001 from VC help (MSDN) 
//    b) static DWORD CALLBACK MyStreamOutCallback(DWORD 
//		 dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
//    c) reads the rich edit control content and put it into a file


#if !defined(AFX_MYRTFDLG_H__072F4897_A9D3_46FE_AD71_2AC66A31D921__INCLUDED_)
#define AFX_MYRTFDLG_H__072F4897_A9D3_46FE_AD71_2AC66A31D921__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "MyRichEditCtrl.h"
#include "MyToolBar.h "
#include "MyStatusBar.h "
#include "MyToolBarCtrl.h "

/////////////////////////////////////////////////////////////////////////////
// CMyRtfDlg dialog

class CMyRtfDlg : public CDialog
{
// Construction
public:
	CMyRtfDlg(CWnd* pParent = NULL);	// standard constructor

	// @cmember
	// My callback procedure that reads the rich edit control content
	// and put it into a file
	// function added on 20 september 2001 from VC help(MSDN)
	static DWORD CALLBACK MyStreamOutCallback(DWORD dwCookie, 
		LPBYTE pbBuff, LONG cb, LONG *pcb);
	void Print(bool bShowPrintDialog);

// Attributes
public:
	// how many lines for file new
	long m_nLinesNew;
	//  for file open
	long m_nLinesOpen;
	bool m_bFisNou;
	bool m_bFisOpen;
	// this var means the dialog app appears and you begin to type
	bool m_bBeginWriting;
	CString m_strFilename;
	CPoint point;
	// I have clicked in the window
	bool m_bClick;
	// I have pressed the TAB key
	bool m_bTab;

	// you begin to type and you save for the first time your file
	// when you save the 2nd,the3rd,etc dialog box with CFileDialog
	// won't appear. You save the file and the app keep in mind you 
	// saved your file with the m_strFilename name and save file with 
	// this name
	int m_nBeginWriting;
	// the same thing 
	int m_nFileNew;
	// for accel table
	HACCEL 	m_hAccel;
// Dialog Data
	//{{AFX_DATA(CMyRtfDlg)
	enum { IDD = IDD_MYRTF_DIALOG };
	CMyRichEditCtrl	m_rtf;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMyRtfDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	HICON m_hIcon;
// @mvar added on Monday 22 octomber 2001
	UINT            m_nIDTracking;
	UINT            m_nIDLastMessage;

	// @member variables added on 21 september 2001
	// @cmember
	// toolbar for our dialog box
	CMyToolBar     m_toolBar;
	CMyToolBarCtrl     m_toolBar1;
	// @member variable added on Monday 8 octomber 2001
	// @cmember
	// statusbar for dialog box
	CMyStatusBar     m_statusBar;
	
	// @member variable added on Thursday 18 Apr 2002
	// @cmember
	// index for toolbar buttons
	int m_index;

// Generated message map functions
	//{{AFX_MSG(CMyRtfDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnFileNew();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnFilePrint();
	afx_msg void OnBold();
	afx_msg void OnItalic();
	afx_msg void OnUnderline();
	afx_msg void OnEditUndo();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnAppAbout();
	afx_msg void OnColour();
	afx_msg void OnClose();
	afx_msg void OnParagraphLeft();
	afx_msg void OnParagraphCenter();
	afx_msg void OnParagraphRight();
	afx_msg void OnParagraphBulleted();
	afx_msg void OnFormatFont();
	afx_msg void OnEditSelectAll();
	afx_msg void OnEditDelete();
	afx_msg void OnChangeBackgroundColor();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBold(CCmdUI* pCmdUI);
	afx_msg void OnUpdateItalic(CCmdUI* pCmdUI);
	afx_msg void OnUpdateUnderline(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnUpdateEditDelete(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateParagraphBulleted(CCmdUI* pCmdUI);
	afx_msg void OnUpdateParagraphCenter(CCmdUI* pCmdUI);
	afx_msg void OnUpdateParagraphLeft(CCmdUI* pCmdUI);
	afx_msg void OnUpdateParagraphRight(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg BOOL OnToolTipText(UINT nID, NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEnterIdle(UINT nWhy, CWnd* pWho);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);
	afx_msg LRESULT OnSetMessageString(WPARAM wParam, LPARAM lParam = 0L);
	afx_msg void OnStatusBarCheck();
	afx_msg void OnToolBarCheck();
	afx_msg void OnUpdateStatusBarMenu(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolBarMenu(CCmdUI* pCmdUI);
	afx_msg void OnUpdateKeyIndicator(CCmdUI* pCmdUI);
	afx_msg LRESULT OnPopMessageString(WPARAM wParam, LPARAM lParam);
	// added on 6 Aug 2003 for updating dialog box controls 
	afx_msg LRESULT OnKickIdle(WPARAM wParam, LPARAM);
	afx_msg LRESULT OnIdleUpdateCmdUI(WPARAM wParam, LPARAM);

	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYRTFDLG_H__072F4897_A9D3_46FE_AD71_2AC66A31D921__INCLUDED_)
